CodeForces 173C Spiral Maximum dp 矩阵降次

题目链接:点击打开链接

题意:

给定n*m的矩阵,可以在矩阵中画出题目图片里黑色的线条。

任选一个点,左下右上的顺序走,走出图里的情况。使得走过的数字和最大,问最大的和。

思路:

点击打开链接

题解比较详细了

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.text.DecimalFormat;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Deque;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Scanner;
import java.util.Stack;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Queue;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

public class Main {

	int n, m;
	int[][] a = new int[N][N], sum = new int[N][N];
	int[][][] s;
	void work() throws Exception {
		n = Int(); m = Int();
		for(int i = 1; i<= n; i++)
			for(int j = 1; j <= m; j++){
				sum[i][j] = a[i][j] = Int();
				if(i>0)
					sum[i][j] += sum[i-1][j];
				if(j>0)
					sum[i][j] += sum[i][j-1];
				if(i>0&&j>0)
					sum[i][j] -= sum[i-1][j-1];
			}
		s = new int[n+1][][];
		for(int i = 1; i <= n; i++)s[i] = new int[m+1][];
		for(int i = 1; i <= n; i++)for(int j = 1; j <= m; j++){
			s[i][j] = new int[min(n+2-i,m+2-j)/2];
			s[i][j][0] = a[i][j];
		}
		int ans = -inf;
		for(int k = 1; k <= 250; k++)
			for(int i = 1; i+2*k <= n; i++)
				for(int j = 1; j + 2*k <= m; j++)
				{
		s[i][j][k] = sum[i+2*k][j+2*k]-sum[i-1][j+2*k]-sum[i+2*k][j-1]+sum[i-1][j-1]-s[i+1][j+1][k-1]-a[i+1][j];

					ans = max(ans, s[i][j][k]);
				}
		out.println(ans);
	}

	public static void main(String[] args) throws Exception {
		Main wo = new Main();
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		// in = new BufferedReader(new InputStreamReader(new FileInputStream(new
		// File("input.txt"))));
		// out = new PrintWriter(new File("output.txt"));
		wo.work();
		out.close();
	}

	static int N = 505;
	static int M = N*2;
	DecimalFormat df = new DecimalFormat("0.0000");
	static int inf = (int) 1e9;
	static long inf64 = (long) 1e18;
	static double eps = 1e-8;
	static double Pi = Math.PI;
	static int mod = (int) 1e9 + 7;

	private String Next() throws Exception {
		while (str == null || !str.hasMoreElements())
			str = new StringTokenizer(in.readLine());
		return str.nextToken();
	}

	private int Int() throws Exception {
		return Integer.parseInt(Next());
	}

	private long Long() throws Exception {
		return Long.parseLong(Next());
	}

	private double Double() throws Exception {
		return Double.parseDouble(Next());
	}

	StringTokenizer str;
	static Scanner cin = new Scanner(System.in);
	static BufferedReader in;
	static PrintWriter out;
/*
	 class Edge{
		 int from, to, dis, nex;
		 Edge(){}
		 Edge(int from, int to, int dis, int nex){
			 this.from = from; this.to = to; this.dis = dis; this.nex = nex;
			 }
		 }
	 Edge[] edge = new Edge[M<<1];
	 int[] head = new int[N]; int edgenum;
	 void init_edge(){
		 for(int i = 0; i < N; i++)head[i] = -1;
		 edgenum = 0;}
	 void add(int u, int v, int dis){
		 edge[edgenum] = new Edge(u, v, dis, head[u]);
		 head[u] = edgenum++;
	}/**/
	int upper_bound(int[] A, int l, int r, int val) {// upper_bound(A+l,A+r,val)-A;
		int pos = r;
		r--;
		while (l <= r) {
			int mid = (l + r) >> 1;
			if (A[mid] <= val) {
				l = mid + 1;
			} else {
				pos = mid;
				r = mid - 1;
			}
		}
		return pos;
	}

	int lower_bound(int[] A, int l, int r, int val) {// upper_bound(A+l,A+r,val)-A;
		int pos = r;
		r--;
		while (l <= r) {
			int mid = (l + r) >> 1;
			if (A[mid] < val) {
				l = mid + 1;
			} else {
				pos = mid;
				r = mid - 1;
			}
		}
		return pos;
	}

	int Pow(int x, int y) {
		int ans = 1;
		while (y > 0) {
			if ((y & 1) > 0)
				ans *= x;
			y >>= 1;
			x = x * x;
		}
		return ans;
	}

	double Pow(double x, int y) {
		double ans = 1;
		while (y > 0) {
			if ((y & 1) > 0)
				ans *= x;
			y >>= 1;
			x = x * x;
		}
		return ans;
	}

	int Pow_Mod(int x, int y, int mod) {
		int ans = 1;
		while (y > 0) {
			if ((y & 1) > 0)
				ans *= x;
			ans %= mod;
			y >>= 1;
			x = x * x;
			x %= mod;
		}
		return ans;
	}

	long Pow(long x, long y) {
		long ans = 1;
		while (y > 0) {
			if ((y & 1) > 0)
				ans *= x;
			y >>= 1;
			x = x * x;
		}
		return ans;
	}

	long Pow_Mod(long x, long y, long mod) {
		long ans = 1;
		while (y > 0) {
			if ((y & 1) > 0)
				ans *= x;
			ans %= mod;
			y >>= 1;
			x = x * x;
			x %= mod;
		}
		return ans;
	}

	int gcd(int x, int y) {
		if (x > y) {
			int tmp = x;
			x = y;
			y = tmp;
		}
		while (x > 0) {
			y %= x;
			int tmp = x;
			x = y;
			y = tmp;
		}
		return y;
	}

	int max(int x, int y) {
		return x > y ? x : y;
	}

	int min(int x, int y) {
		return x < y ? x : y;
	}

	double max(double x, double y) {
		return x > y ? x : y;
	}

	double min(double x, double y) {
		return x < y ? x : y;
	}

	long max(long x, long y) {
		return x > y ? x : y;
	}

	long min(long x, long y) {
		return x < y ? x : y;
	}

	int abs(int x) {
		return x > 0 ? x : -x;
	}

	double abs(double x) {
		return x > 0 ? x : -x;
	}

	long abs(long x) {
		return x > 0 ? x : -x;
	}

	boolean zero(double x) {
		return abs(x) < eps;
	}

	double sin(double x) {
		return Math.sin(x);
	}

	double cos(double x) {
		return Math.cos(x);
	}

	double tan(double x) {
		return Math.tan(x);
	}

	double sqrt(double x) {
		return Math.sqrt(x);
	}
}
时间: 2024-10-27 05:13:44

CodeForces 173C Spiral Maximum dp 矩阵降次的相关文章

Codeforces 75D Big Maximum Sum 最大子段和 dp

题目链接:点击打开链接 题意: 第一行 n m n个vector 下面n行 第一个数字u表示vector 的大小,然后后面u个数字给出这个vector 最后一行m个数字 表示把上面的vector拼接起来 得到一个大序列,求这个大序列的最大子段和 先预处理出每个vector的最大子段和,左起连续最大,右起连续最大,所有数的和 然后dp 一下.. #include <cstdio> #include <iostream> #include <algorithm> #incl

Codeforces 41D Pawn 简单dp

题目链接:点击打开链接 给定n*m 的矩阵 常数k 下面一个n*m的矩阵,每个位置由 0-9的一个整数表示 问: 从最后一行开始向上走到第一行使得路径上的和 % (k+1) == 0 每个格子只能向或走一步 求:最大的路径和 最后一行的哪个位置作为起点 从下到上的路径 思路: 简单dp #include <cstdio> #include <algorithm> #include<iostream> #include<string.h> #include &

POJ3735 Training little cats DP,矩阵快速幂,稀疏矩阵优化

题目大意是,n只猫,有k个动作让它们去完成,并且重复m次,动作主要有三类gi,ei,s i j,分别代表第i只猫获得一个花生,第i只猫吃掉它自己所有的花生,第i只和第j只猫交换彼此的花生.k,n不超过100,m不超过1000,000,000,计算出最后每只猫还剩下多少个花生. 我们假设一个n维向量P,每个分量的值代表这n只猫所拥有的花生数,那么对于gi操作其实就是在第i维分量上加上1:对于ei,那就是在第i维分量上乘以0,说到这里,有木有感觉这很像3D坐标转化中的平移矩阵和缩放矩阵?没错,就是这

CodeForces 18E Flag 2 dp

题目链接:点击打开链接 #include<stdio.h> #include<iostream> #include<string.h> #include<set> #include<vector> #include<map> #include<math.h> #include<queue> #include<string> #include<stdlib.h> #include<a

HDU 2294 Pendant (DP+矩阵快速幂降维)

HDU 2294 Pendant (DP+矩阵快速幂降维) ACM 题目地址:HDU 2294 Pendant 题意: 土豪给妹子做首饰,他有K种珍珠,每种N个,为了炫富,他每种珍珠都要用上.问他能做几种长度[1,N]的首饰. 分析: 1 ≤ N ≤ 1,000,000,000简直可怕. 首先想dp,很明显可以想到: dp[i][j] = (k-(j-1))*dp[i-1][j-1] + j*dp[i-1][j](dp[i][j]表示长度为i的并且有j种珍珠的垂饰有多少个) 然后遇到N太大的话,

CodeForces 19B Checkout Assistant dp

题目链接:点击打开链接 #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #include <iostream> #include <map> #include <set> #include <math.h> using namespace std; #define inf 115292150460684697

POJ3420 Quad Tiling DP + 矩阵快速幂

题目大意是用1*2的骨牌堆积成4*N的矩形,一共有多少种方法,N不超过10^9. 这题和曾经在庞果网上做过的一道木块砌墙几乎一样.因为骨牌我们可以横着放,竖着放,我们假设以4为列,N为行这样去看,并且在骨牌覆盖的位置上置1,所以一共最多有16种状态.我们在第M行放骨牌的时候,第M+1行的状态也是有可能被改变的,设S(i,j)表示某一行状态为i时,将其铺满后下一行状态为j的方案书.考虑下如果我们让矩阵S和S相乘会有什么意义,考虑一下会发现S*S的意义当某行状态为i,接着其后面第2行的状态为j的可行

HDU5863 cjj&#39;s string game(DP + 矩阵快速幂)

题目 Source http://acm.split.hdu.edu.cn/showproblem.php?pid=5863 Description cjj has k kinds of characters the number of which are infinite. He wants to build two strings with the characters. The lengths of the strings are both equal to n. cjj also def

HDU 5434 Peace small elephant 状压dp+矩阵快速幂

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=5434 Peace small elephant Accepts: 38 Submissions: 108 Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others) 问题描述 小明很喜欢国际象棋,尤其喜欢国际象棋里面的大象(只要无阻挡能够斜着走任意格),但是他觉得国际象棋里的大象太凶残了,于是他